// ZipNFindDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ZipNFind.h"
#include "ZipNFindDlg.h"

#include "OptionsDlg.h"

extern "C"
{
	#include "CGrepLib.h"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define DUMMY	"$$DUMMY$$"

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CZipNFindDlg dialog



CZipNFindDlg::CZipNFindDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZipNFindDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	spaceless = true;
	jumpers = 128;
	cancelled = false;
}

CZipNFindDlg::~CZipNFindDlg()
{
}

void CZipNFindDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FILES, tvFiles);
	DDX_Control(pDX, IDC_PROGRESS, progProgress);
	DDX_Control(pDX, IDC_STATIC_PROGRESS, statProgress);
	DDX_Control(pDX, IDC_CANCEL, cmdCancel);
	DDX_Control(pDX, IDC_COMPRESS, cmdCompress);
	DDX_Control(pDX, IDC_DECOMPRESS, cmdDecompress);
	DDX_Control(pDX, IDC_CLEAN, cmdClean);
	DDX_Control(pDX, IDC_OPTIONS, cmdOptions);
	DDX_Control(pDX, IDOK, cmdExit);
	DDX_Control(pDX, IDC_SEARCH, cmdSearch);
	DDX_Control(pDX, IDC_CLEAN_ORIG, cmdCleanOrig);
	DDX_Control(pDX, IDC_LIST_RESULTS, listResults);
	DDX_Control(pDX, IDC_EDIT_ERRORS, edtErrors);
	DDX_Control(pDX, IDC_EDIT_SEARCH, edtWord);
}

BEGIN_MESSAGE_MAP(CZipNFindDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_FILES, OnTvnItemexpandingFiles)
	ON_BN_CLICKED(IDC_OPTIONS, OnBnClickedOptions)
	ON_BN_CLICKED(IDC_COMPRESS, OnBnClickedCompress)
	ON_BN_CLICKED(IDC_CANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_CLEAN, OnBnClickedClean)
	ON_BN_CLICKED(IDC_CLEAN_ORIG, OnBnClickedCleanOrig)
	ON_BN_CLICKED(IDC_DECOMPRESS, OnBnClickedDecompress)
	ON_BN_CLICKED(IDC_SEARCH, OnBnClickedSearch)
	ON_BN_CLICKED(IDC_VIEWLOG, OnBnClickedViewlog)
END_MESSAGE_MAP()


// CZipNFindDlg message handlers

void CZipNFindDlg::GetPathFromTree(HTREEITEM hi, char *buf)
{
	char buf2[10000];
	HTREEITEM nexthi;
	sprintf(buf, "");
	do
	{
		sprintf(buf2, "%s", buf);
		nexthi = tvFiles.GetParentItem(hi);
		if(nexthi) sprintf(buf, "%s%\\%s", tvFiles.GetItemText(hi).GetString(), buf2);
		else sprintf(buf, "%s%:\\%s", tvFiles.GetItemText(hi).GetString(), buf2);
	} while(hi = nexthi);
	//Remove trailing backslash
	if(strlen(buf)>0) buf[strlen(buf) - 1] = 0;
};

HTREEITEM CZipNFindDlg::GetNodeFromPath(char *buf)
{
	char buf2[10000];
	HTREEITEM hi;
	hi = tvFiles.GetRootItem();
	while(tvFiles.GetItemText(hi).GetString()[0] != buf[0])
	{
		if(!hi) return 0;
		hi = tvFiles.GetNextSiblingItem(hi);
	};
	buf += 3;
	while(*buf)
	{
		if(strchr(buf, '\\'))
		{
			strncpy(buf2, buf, strchr(buf, '\\') - buf);
			buf2[strchr(buf, '\\') - buf] = 0;
			buf = strchr(buf, '\\') + 1;
		}
		else
		{
			sprintf(buf2, buf);
			buf += strlen(buf);
		};
		hi = tvFiles.GetChildItem(hi);
		while(strcmp(tvFiles.GetItemText(hi).GetString(), buf2) != 0)
		{
			if(!hi) return 0;
			hi = tvFiles.GetNextSiblingItem(hi);
		};
	};
	return hi;
};

void GetFileNameFromPath(char *path, char *name)
{
	if(strrchr(path, '\\')) sprintf(name, "%s", strrchr(path, '\\') + 1);
	else sprintf(name, "%s", path);
	if(strlen(name) > 4) if(strcmp(name + strlen(name) - 4, ".hwz") == 0) name[strlen(name) - 4] = 0;
};

void CZipNFindDlg::ExpandItem(HTREEITEM hi)
{
	HTREEITEM nexthi;
	char buf[10000];
	CFileFind ff, ff2;
	bool found;

	//Checks for dummy node and removes it or terminates function if no such
	nexthi = tvFiles.GetChildItem(hi);
	if(!nexthi) return;
	if(strcmp(tvFiles.GetItemText(nexthi).GetString(), DUMMY) != 0) return;
	tvFiles.DeleteItem(nexthi);
	
	GetPathFromTree(hi, buf);
	sprintf(buf + strlen(buf), "\\*.*");
	found = ff.FindFile(buf);
	while(found)
	{
		found = ff.FindNextFile();
		if(ff.IsDirectory())
		{
			//Directory
			if(strcmp(ff.GetFileName().GetString(), ".") != 0 && strcmp(ff.GetFileName().GetString(), "..") != 0)
			{
				nexthi = tvFiles.InsertItem(ff.GetFileName().GetString(), 1, 1, hi, TVI_SORT);
				tvFiles.InsertItem(DUMMY, 0, 0, nexthi);
				tvFiles.Expand(nexthi, TVE_COLLAPSE);
			};
		}
		else
		{
			//Single file
			if(strncmp(ff.GetFileName().GetString() + strlen(ff.GetFileName().GetString()) - 4, ".hwz", 4) == 0)
			{
				//Compressed file
				sprintf(buf, "%s", ff.GetFilePath().GetString());
				buf[strlen(buf) - 4] = 0;
				if(ff2.FindFile(buf))
				{
					//Compressed file - part of pair
					ff2.FindNextFile();
					nexthi = tvFiles.InsertItem(ff2.GetFileName().GetString(), 5, 5, hi, TVI_SORT);
				}
				else
				{
					//Single compressed file
					nexthi = tvFiles.InsertItem(ff.GetFileName().GetString(), 4, 4, hi, TVI_SORT);
				};
			}
			else
			{
				//Regular file
				sprintf(buf, "%s.hwz", ff.GetFilePath().GetString());
				if(!ff2.FindFile(buf))
				{	
					//If it has a pair then it is already handled in the other case
					nexthi = tvFiles.InsertItem(ff.GetFileName().GetString(), 3, 3, hi, TVI_SORT);
				};
			};
		};
	};
	//Moves files below directories
	HTREEITEM movedhi, firstmoved;
	nexthi = tvFiles.GetChildItem(hi);
	firstmoved = 0;
	while(nexthi != 0)
	{
		int i;

		tvFiles.GetItemImage(nexthi, i, i);
		if(i > 2)
		{
			movedhi = nexthi;
			if(movedhi == firstmoved) break;
			nexthi = tvFiles.GetNextSiblingItem(nexthi);
			sprintf(buf, "%s", tvFiles.GetItemText(movedhi).GetString());
			tvFiles.DeleteItem(movedhi);
			movedhi = tvFiles.InsertItem(buf, i, i, hi, TVI_LAST);
			if(firstmoved == 0) firstmoved = movedhi;
		}
		else nexthi = tvFiles.GetNextSiblingItem(nexthi);
	};
};

void CZipNFindDlg::RefreshTree()
{
	HTREEITEM hi = tvFiles.GetRootItem();
	while(hi)
	{
		while(tvFiles.GetChildItem(hi)) tvFiles.DeleteItem(tvFiles.GetChildItem(hi));
		tvFiles.InsertItem(DUMMY, 0, 0, hi);
		ExpandItem(hi);
		hi = tvFiles.GetNextSiblingItem(hi);
	};
};

void CZipNFindDlg::InitializeTree()
{
	CFileFind ff;
	char drive;
	char buf[7];
	HTREEITEM hi;
	for(drive = 'a'; drive <= 'z'; drive++)
	{
		sprintf(buf, "%c:\\*.*", drive);
		if(ff.FindFile(buf))
		{
			buf[1] = 0;
			hi = tvFiles.InsertItem(buf, 0, 0);
			tvFiles.InsertItem(DUMMY, 0, 0, hi);
			tvFiles.Expand(hi, TVE_COLLAPSE);
			ExpandItem(hi);
		};
	};
};

BOOL CZipNFindDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	//Redirect standard output and error streams to the log file
	*stdout = *(fopen("ZipNFind.log", "w"));
	*stderr = *stdout;
	setvbuf(stdout, NULL, _IONBF, 0); 
	setvbuf(stderr, NULL, _IONBF, 0); 
	//Initiate result list control
	listResults.InsertColumn(0, "File", LVCFMT_LEFT, 110);
	listResults.InsertColumn(1, "Position", LVCFMT_LEFT, 60);
	listResults.InsertColumn(2, "Left context", LVCFMT_RIGHT, 138);
	listResults.InsertColumn(3, "Word", LVCFMT_CENTER, 90);
	listResults.InsertColumn(4, "Right context", LVCFMT_LEFT, 138);
	//Check for agrep
	STARTUPINFO si;
    PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(si) );
	si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );
    if(!CreateProcess( NULL, "agrep -V", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) 
    {
		agrepOK = false;
		AfxMessageBox("agrep not found\n\nPlease install agrep for Windows and make sure that it is accessible through the command 'agrep'.\nWithout agrep you will not be able to search.", MB_APPLMODAL | MB_ICONEXCLAMATION | MB_OK);
    } else agrepOK = true;
	cmdSearch.EnableWindow(agrepOK);
    WaitForSingleObject(pi.hProcess, INFINITE);
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
	// Image list for tree view
	il.Create(16, 16, ILC_COLOR, 0, 6);
	CBitmap b[6];
	b[0].LoadBitmap(IDB_DRIVE);
	il.Add(&b[0], RGB(0, 255, 255));
	b[1].LoadBitmap(IDB_CLOSED);
	il.Add(&b[1], RGB(0, 255, 255));
	b[2].LoadBitmap(IDB_OPEN);
	il.Add(&b[2], RGB(0, 255, 255));
	b[3].LoadBitmap(IDB_FILE);
	il.Add(&b[3], RGB(0, 255, 255));
	b[4].LoadBitmap(IDB_COMPRESSED);
	il.Add(&b[4], RGB(0, 255, 255));
	b[5].LoadBitmap(IDB_BOTH);
	il.Add(&b[5], RGB(0, 255, 255));
	tvFiles.SetImageList(&il, TVSIL_NORMAL);
	//Progress bar
	progProgress.SetRange(0, 0);
	// Initialize directory tree
	InitializeTree();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CZipNFindDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CZipNFindDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CZipNFindDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CZipNFindDlg::OnTvnItemexpandingFiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	
	// TODO: Add your control notification handler code here
	ExpandItem(tvFiles.GetSelectedItem());

	*pResult = 0;
}




void CZipNFindDlg::OnBnClickedOptions()
{
	// TODO: Add your control notification handler code here
	COptionsDlg od;
	od.intSpaceless = spaceless?BST_CHECKED:BST_UNCHECKED;
	od.intJumpers = jumpers;
	if(od.DoModal() == IDOK)
	{
		spaceless = (od.intSpaceless==BST_CHECKED)?true:false;
		jumpers = od.intJumpers;
	};
}

//A routine for handling system errors.
//Displays a message box with some given text and system error information.
void MyError(char *title)
{
	LPVOID lpMsgBuf;
	char *msg;
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);
	msg = new char[strlen(title) + strlen((char *)lpMsgBuf) + 5];
	sprintf(msg, "%s\n\n%s", title, lpMsgBuf);
	AfxMessageBox(msg, MB_OK | MB_APPLMODAL | MB_ICONERROR);
	delete [] msg;
};

void AdvanceProgress(CZipNFindDlg *theDialog)
{
	//Update progress bar and buttons
	int l, u, p;
	CSingleLock csprog(&(theDialog->progcs));
	csprog.Lock();
	p = theDialog->progProgress.GetPos();
	theDialog->progProgress.GetRange(l, u);
	theDialog->progProgress.SetPos(p + 1);
	if(p + 1 == u)
	{
		theDialog->progProgress.SetRange(0, 0);
		theDialog->statProgress.SetWindowText("Finished");
		theDialog->cmdCancel.EnableWindow(false);
		theDialog->cmdCompress.EnableWindow(true);
		theDialog->cmdDecompress.EnableWindow(true);
		theDialog->cmdClean.EnableWindow(true);
		theDialog->cmdCleanOrig.EnableWindow(true);
		theDialog->cmdExit.EnableWindow(true);
		theDialog->cmdSearch.EnableWindow(theDialog->agrepOK);
		theDialog->cancelled = false;
	};
	csprog.Unlock();
};

//A worker thread for compressing a file.
UINT threadedCompress(LPVOID param)
{
	sThreadOptions *to = (sThreadOptions *)param;
	char outfname[10000];
	LPVOID intext;
	int insize;
	HANDLE inf, outf, infmap;		//file handles and map handle
	DWORD byteswritten;
	char *archive;
	int archivesize;
	bool successful = false, exraised = false;


	//Only one thread at a time
	CSingleLock cs(&(to->theDialog->threadcs));
	cs.Lock();

	//If cancelled
	if(to->theDialog->cancelled) goto finished;

	//Progress label
	sprintf(outfname, "Compressing %s...", to->fname);
	to->theDialog->statProgress.SetWindowText(outfname);
	fprintf(stdout, "\n=== Compressing %s ===\n", to->fname);
	
	//Open input file
	inf = CreateFile(to->fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if(inf==INVALID_HANDLE_VALUE) MyError("Error opening input file.");
	else
	{
		//Create file mapping
		insize = GetFileSize(inf, NULL);
		infmap = CreateFileMapping(inf, NULL, PAGE_READONLY, 0, insize, NULL);
		if(infmap == NULL) MyError("Error creating file mapping.");
		else
		{
			//Map file view into memory
			intext = MapViewOfFile(infmap, FILE_MAP_READ, 0, 0, 0);
			if(intext == NULL) MyError("Error mapping view of file.");
			else
			{
				//Open output file
				sprintf(outfname, "%s.hwz", to->fname);
				outf = CreateFile(outfname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				if(outf == INVALID_HANDLE_VALUE) MyError("Error creating archive file.");
				else
				{
					//Compress file
					try
					{
						if(to->theDialog->spaceless)
							Huffw_spaceless_compress((char *)intext, insize, 
								&archive, &archivesize, 1);
						else Huffw_compress((char *)intext, insize, (to->theDialog->jumpers>0)?to->theDialog->jumpers:0, 
								&archive, &archivesize, 1);
					}
					catch(...)
					{
						exraised = true;
						AfxMessageBox("Compression failed. See log file for details.", MB_APPLMODAL | MB_ICONERROR | MB_OK, 0);
					};
					//Write output
					if(!exraised)
					{
						if(WriteFile(outf, archive, archivesize, &byteswritten, NULL) == 0)
							MyError("Error writing to archive file.");
						successful = true;
						free(archive);
					};
					CloseHandle(outf);
				};
				UnmapViewOfFile(intext);
			};
			CloseHandle(infmap);
		};
		CloseHandle(inf);
	};

	//Update tree
	if(successful)
	{
		HTREEITEM hi = to->theDialog->GetNodeFromPath(to->fname);
		to->theDialog->tvFiles.SetItemImage(hi, 5, 5);
	};

finished:
	AdvanceProgress(to->theDialog);
	delete to;
	cs.Unlock();
	return 0;
};

//A worker thread for decompressing a file.
UINT threadedDecompress(LPVOID param)
{
	sThreadOptions *to = (sThreadOptions *)param;
	bool successful = false, validfile, exraised = false;
	char outfname[10000];
	LPVOID intext;
	int insize;
	HANDLE inf, infmap;

	//Only one thread at a time
	CSingleLock cs(&(to->theDialog->threadcs));
	cs.Lock();
	
	//If cancelled
	if(to->theDialog->cancelled) goto finished;

	//Progress label
	sprintf(outfname, "Decompressing %s...", to->fname);
	to->theDialog->statProgress.SetWindowText(outfname);
	fprintf(stdout, "\n=== Decompressing %s ===\n", to->fname);

	//Output file name
	sprintf(outfname, "%s", to->fname);
	validfile = true;
	if(strlen(outfname) < 5) validfile = false;
	else if(strcmp(outfname + strlen(outfname) - 4, ".hwz") != 0)  validfile = false;
	else outfname[strlen(outfname) - 4] = 0;

	//Decompress
	if(validfile)
	{
		//Open input file
		inf = CreateFile(to->fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if(inf==INVALID_HANDLE_VALUE) MyError("Error opening input file.");
		else
		{
			//Create file mapping
			insize = GetFileSize(inf, NULL);
			infmap = CreateFileMapping(inf, NULL, PAGE_READONLY, 0, insize, NULL);
			if(infmap == NULL) MyError("Error creating file mapping.");
			else
			{
				//Map file view into memory
				intext = MapViewOfFile(infmap, FILE_MAP_READ, 0, 0, 0);
				if(intext == NULL) MyError("Error mapping view of file.");
				else
				{
					//Create output file
					HANDLE f = CreateFile(outfname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
					if(f == INVALID_HANDLE_VALUE) MyError("Error opening file for writing");
					else
					{
						char *Output_string;
						int Output_size;
						try
						{
							if(!(*((char *)intext))) Huffw_decompress(((char *)intext), insize, &Output_string, &Output_size, 1);
							else Huffw_spaceless_decompress(((char *)intext), insize, &Output_string, &Output_size, 1);
						}
						catch(...)
						{
							exraised = true;
							AfxMessageBox("Decompression failed. See log file for details.", MB_APPLMODAL | MB_ICONERROR | MB_OK, 0);
						};
						//Write output
						if(!exraised)
						{
							DWORD read;
							if(!WriteFile(f, Output_string, Output_size, &read, NULL)) MyError("Error writing to file");
							else successful = true;
							free(Output_string);
						};
						CloseHandle(f);
					};
					UnmapViewOfFile(intext);
				};
				CloseHandle(infmap);
			};
			CloseHandle(inf);
		};
	};
	
	//Update tree
	if(successful)
	{
		//If the original file didn't exist already then turn the compressed node into a couple
		if(!to->theDialog->GetNodeFromPath(outfname))
		{
			HTREEITEM hi = to->theDialog->GetNodeFromPath(to->fname);
			sprintf(outfname, "%s", to->theDialog->tvFiles.GetItemText(hi).GetString());
			outfname[strlen(outfname) - 4] = 0;
			to->theDialog->tvFiles.SetItemText(hi, outfname);
			to->theDialog->tvFiles.SetItemImage(hi, 5, 5);
		};
	};

finished:
	AdvanceProgress(to->theDialog);
	delete to;
	cs.Unlock();
	return 0;
};

/* Turns all non alphanumeric characters into spaces
- for esthetic reasons when printing the context. */
void RemoveNonprintables(char *str)
{
	while(*str)
	{
		if((unsigned char)(*str) < 32) *str=' ';
		str++;
	};
};

//A worker thread for searching.
UINT threadedSearch(LPVOID param)
{
	sThreadOptions *to = (sThreadOptions *)param;
	LPVOID intext;
	int insize;
	HANDLE inf, infmap;
	char buf[10000];
	bool exraised = false;

	//Only one thread at a time
	CSingleLock cs(&(to->theDialog->threadcs));
	cs.Lock();

	//If cancelled
	if(to->theDialog->cancelled) goto finished;

	//Progress label
	sprintf(buf, "Searching %s...", to->fname);
	to->theDialog->statProgress.SetWindowText(buf);
	fprintf(stdout, "\n=== Searching %s ===\n", to->fname);
	
	//Search
    //Open input file
	inf = CreateFile(to->fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if(inf==INVALID_HANDLE_VALUE) MyError("Error opening input file.");
	else
	{
		//Create file mapping
		insize = GetFileSize(inf, NULL);
		infmap = CreateFileMapping(inf, NULL, PAGE_READONLY, 0, insize, NULL);
		if(infmap == NULL) MyError("Error creating file mapping.");
		else
		{
			//Map file view into memory
			intext = MapViewOfFile(infmap, FILE_MAP_READ, 0, 0, 0);
			if(intext == NULL) MyError("Error mapping view of file.");
			else
			{
				//Perform search
				int *position;
				int nocc;
				int errors;
			    
				//Extract word and number of errors 
				to->theDialog->edtErrors.GetWindowText(buf, 999);
				errors = atoi(buf);
				to->theDialog->edtWord.GetWindowText(buf, 999);

				//Search
				__try
				{
					position = CGrep_SearchWord(&nocc, buf, ((char *)intext), insize, errors);
				}
				__except(1)
				{
					exraised = true;
					AfxMessageBox("Search failed. See log file for details.", MB_APPLMODAL | MB_ICONERROR | MB_OK, 1);
				};
				
				//Display results
				if(nocc && !exraised)
				{
					int scanned;
					Console console;
					char *cbody;
					int clen, textlen;
					HDecompress_getBodyAndConsole(((char *)intext), insize, &textlen, &cbody, &clen, &console); 

					for (scanned = 0; scanned < nocc; scanned++ )  // for each match
					{
						char *prev = NULL, *next = NULL; 
						int prevLen = 0, nextLen = 0, decoded, wordlen;

						//File name
						GetFileNameFromPath(to->fname, buf);
						to->theDialog->listResults.InsertItem(scanned, buf);

						//Position
						sprintf(buf, "%d", position[scanned]);
						to->theDialog->listResults.SetItem(scanned, 1, LVIF_TEXT, buf, 0, 0, 0, 0);
					
						//left context
						__try
						{
							if (*((char *)intext)) HDecompress_previousBlock_tokens_spaceless(cbody + position[scanned], position[scanned], 3, &prev, &prevLen, &decoded, &console);
							else HDecompress_previousBlock_tokens(cbody + position[scanned], position[scanned], 3, &prev, &prevLen, &decoded, &console);
						}
						__except(1)
						{
							AfxMessageBox("Error decompressing left context.", MB_APPLMODAL | MB_ICONERROR | MB_OK, 0);
							break;
						};
						if(prevLen)
						{
							prev[prevLen] = '\0'; // null-terminate the string
							RemoveNonprintables(prev);
							to->theDialog->listResults.SetItem(scanned, 2, LVIF_TEXT, prev, 0, 0, 0, 0);
						};
						//right context and the word
						__try
						{
							if (*((char *)intext)) HDecompress_nextBlock_tokens_spaceless(cbody + position[scanned], clen - position[scanned], 4, &next, &nextLen, &decoded, &console);
							else HDecompress_nextBlock_tokens(cbody + position[scanned], clen - position[scanned], 4, &next, &nextLen, &decoded, &console);
						}
						__except(1)
						{
							AfxMessageBox("Error decompressing right context.", MB_APPLMODAL | MB_ICONERROR | MB_OK, 0);
							break;
						};
						if(nextLen)
						{
							next[nextLen] = '\0'; // null-terminate the string
							HToken_getLengthNext(next, nextLen, &wordlen);
							next[wordlen] = '\0';
							to->theDialog->listResults.SetItem(scanned, 3, LVIF_TEXT, next, 0, 0, 0, 0);
							if(wordlen < nextLen)
							{
								RemoveNonprintables(next + wordlen + 1);
								to->theDialog->listResults.SetItem(scanned, 4, LVIF_TEXT, next + wordlen + 1, 0, 0, 0, 0);
							};
						};
						if(prev) free(prev); // frees the buffers
						if(next) free(next);
					};
					FreeTheConsole(&console, 0);
				};
				if(!exraised) free(position);	
				UnmapViewOfFile(intext);
			};
			CloseHandle(infmap);
		};
		CloseHandle(inf);
	};

finished:
	AdvanceProgress(to->theDialog);
	delete to;
	cs.Unlock();
	return 0;
};

void CZipNFindDlg::ProcessFile(char *fname, int action)
{
	int l, u;
	CSingleLock csprog(&progcs);
	CFileFind ff;
	char buf[10000];
	
	csprog.Lock();

	progProgress.GetRange(l, u);
	progProgress.SetRange(l, u + 1);
	switch(action)
	{
	case 1: statProgress.SetWindowText("Compressing..."); break;
	case 2: statProgress.SetWindowText("Decompressing"); break;
	case 3: statProgress.SetWindowText("Removing compressed files..."); break;
	case 4: statProgress.SetWindowText("Removing original files..."); break;
	case 5: statProgress.SetWindowText("Searching..."); break;
	};
	cmdCompress.EnableWindow(false);
	cmdDecompress.EnableWindow(false);
	cmdClean.EnableWindow(false);
	cmdCleanOrig.EnableWindow(false);
	cmdSearch.EnableWindow(false);
	cmdExit.EnableWindow(false);
	
	//If it is threaded action then create parameter structure for thread
	sThreadOptions *to;
	if(action == 1 || action == 2 || action == 5)
	{
		to = new sThreadOptions;
		sprintf(to->fname, "%s", fname);
		to->theDialog = this;
	};

	switch(action)
	{
	case 1: 
		AfxBeginThread(threadedCompress, to);
		break;
	case 2: 
		AfxBeginThread(threadedDecompress, to);
		break;
	case 3:
		//Remove compressed only if original exists
		sprintf(buf, "%s", fname);
		if(strlen(buf) > 4) if(strcmp(buf + strlen(buf) - 4, ".hwz") == 0)
		{
			buf[strlen(buf) - 4] = 0;
			if(ff.FindFile(buf))
			{
				if(remove(fname)!=0) MyError("Error removing file");
				else
				{
					//Update tree
					HTREEITEM hi = GetNodeFromPath(buf);
					tvFiles.SetItemImage(hi, 3, 3);
				};
			};
		};
		AdvanceProgress(this);
		break;
	case 4:
		//Remove original only if compressed exists
		sprintf(buf, "%s.hwz", fname);
		if(ff.FindFile(buf))
		{
			if(remove(fname)!=0) MyError("Error removing file");
			else
			{
				//Update tree
				HTREEITEM hi = GetNodeFromPath(fname);
				sprintf(buf, "%s.hwz", tvFiles.GetItemText(hi).GetString());
				tvFiles.SetItemText(hi, buf);
				tvFiles.SetItemImage(hi, 4, 4);
			};
		};
		AdvanceProgress(this);
		break;
	case 5: 
		AfxBeginThread(threadedSearch, to);
		break;
	};
	csprog.Unlock();
};

void CZipNFindDlg::ProcessDirectory(char *fname, int action)
{
	CFileFind ff;
	char buf[10000];
	bool found;

	sprintf(buf, "%s\\*.*", fname);
	found = ff.FindFile(buf);
	while(found)
	{
		found = ff.FindNextFile();
		if(ff.IsDirectory())
		{
			//Process unless fake directory . or ..
			if(strcmp(ff.GetFileName().GetString(), ".") != 0 && strcmp(ff.GetFileName().GetString(), "..") != 0)
				ProcessDirectory((char *)ff.GetFilePath().GetString(), action);
		}
		else
		{
			//Process depending on action and type of file
			if(action == 1 || action == 4)
				//Compress or remove original only if not compressed
				if(strcmp(ff.GetFileName().GetString() + strlen(ff.GetFileName().GetString()) - 4, ".hwz") != 0)
					ProcessFile((char *)ff.GetFilePath().GetString(), action);
			if(action == 2 || action == 3 || action == 5)
				//Decompress, remove compressed or search only if compressed
				if(strcmp(ff.GetFileName().GetString() + strlen(ff.GetFileName().GetString()) - 4, ".hwz") == 0)
					ProcessFile((char *)ff.GetFilePath().GetString(), action);
		};
	};
};

void CZipNFindDlg::ProcessAction(int action)
{
	int i;
	HTREEITEM hi = tvFiles.GetSelectedItem();
	char buf[10000];

	if(!hi)
	{
		AfxMessageBox("No file or directory selected", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};
	tvFiles.GetItemImage(hi, i, i);
	//Can not apply compress to compressed files
	if((i == 4 || i == 5) && action == 1)
	{
		AfxMessageBox("The selected file is compressed", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};
	//Can not apply clean originals to compressed only files
	if(i == 4 && action == 4)
	{
		AfxMessageBox("The selected file is compressed", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};
	//Can not apply clean originals to regular only files
	if(i == 3 && action == 4)
	{
		AfxMessageBox("The selected file does not have a compressed version", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};
	//Can not apply clean compress to regular files
	if(i == 3 && action == 3)
	{
		AfxMessageBox("The selected file is not compressed", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};
	//Can not apply clean compress to compressed only files
	if(i == 4 && action == 3)
	{
		AfxMessageBox("The selected file does not have an uncompressed version", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};
	//Can not apply decompress or search to uncompressed only files
	if(i == 3 && (action == 2 || action == 5))
	{
		AfxMessageBox("The selected file is not compressed", MB_APPLMODAL | MB_ICONINFORMATION | MB_OK, 0);
		return;
	};

	GetPathFromTree(hi, buf);
	if(i == 5 && (action == 2 || action == 3 || action == 5))
		sprintf(buf + strlen(buf), ".hwz");
	if(action == 5) listResults.DeleteAllItems();
	cmdCancel.EnableWindow(true);
	cancelled = false;
	if(i >= 3) ProcessFile(buf, action);
	else ProcessDirectory(buf, action);
};

void CZipNFindDlg::OnBnClickedCompress()
{
	// TODO: Add your control notification handler code here
	ProcessAction(1);
}

void CZipNFindDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code herecs.Lock();
	CSingleLock cs(&progcs);
	cs.Lock();
	cmdCancel.EnableWindow(false);
	cancelled = true;
	statProgress.SetWindowText("Cancelling...");
	cs.Unlock();
}

void CZipNFindDlg::OnBnClickedClean()
{
	// TODO: Add your control notification handler code here
	ProcessAction(3);
}

void CZipNFindDlg::OnBnClickedCleanOrig()
{
	// TODO: Add your control notification handler code here
	ProcessAction(4);
}

void CZipNFindDlg::OnBnClickedDecompress()
{
	// TODO: Add your control notification handler code here
	ProcessAction(2);
}

void CZipNFindDlg::OnBnClickedSearch()
{
	// TODO: Add your control notification handler code here
	ProcessAction(5);
}

void CZipNFindDlg::OnBnClickedViewlog()
{
	STARTUPINFO si;
    PROCESS_INFORMATION pi;

    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );

    if( !CreateProcess( NULL, "notepad ZipNFind.log", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi )) 
		AfxMessageBox("Error running notepad. You can find ZipNFind.log in the ZipNFind application folder.", MB_APPLMODAL | MB_ICONERROR | MB_OK, 0);
}
