// ZipNFindDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "afxmt.h"

class CZipNFindDlg;

//A structure for passing data to worker threads
struct sThreadOptions
{
	char fname[10000];
	CZipNFindDlg *theDialog;
};


// CZipNFindDlg dialog
class CZipNFindDlg : public CDialog
{
// Construction
public:
	CZipNFindDlg(CWnd* pParent = NULL);	// standard constructor
	~CZipNFindDlg();

// Dialog Data
	enum { IDD = IDD_ZIPNFIND_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	void InitializeTree();
	void RefreshTree();
	void ExpandItem(HTREEITEM hi);
	void GetPathFromTree(HTREEITEM hi, char *buf);
	HTREEITEM GetNodeFromPath(char *buf);
	void ProcessFile(char *fname, int action);
	void ProcessDirectory(char *fname, int action);
	void ProcessAction(int action);
	CTreeCtrl tvFiles;
	CImageList il;
	int jumpers;
	bool spaceless;
	bool agrepOK;
	bool cancelled;
	CCriticalSection progcs;
	CCriticalSection threadcs;
	afx_msg void OnTvnItemexpandingFiles(NMHDR *pNMHDR, LRESULT *pResult);
	CProgressCtrl progProgress;
	CStatic statProgress;
	afx_msg void OnBnClickedOptions();
	afx_msg void OnBnClickedCompress();
	CButton cmdCancel;
	CButton cmdCompress;
	CButton cmdDecompress;
	CButton cmdClean;
	CButton cmdOptions;
	CButton cmdExit;
	CButton cmdSearch;
	afx_msg void OnBnClickedCancel();
	CButton cmdCleanOrig;
	afx_msg void OnBnClickedClean();
	afx_msg void OnBnClickedCleanOrig();
	afx_msg void OnBnClickedDecompress();
	afx_msg void OnBnClickedSearch();
	CListCtrl listResults;
	CEdit edtErrors;
	CEdit edtWord;
	afx_msg void OnBnClickedViewlog();
};
